#include <GL/glut.h>
#include "GameObj.h"
#include "Ast.h"
#include "Ast3DFract.h"


#ifdef _WIN32
#define drand48() (((float) rand())/((float) RAND_MAX))
#define srand48(x) (srand((x)))
#endif

void Ast3DFract::Draw()
{
	glPushMatrix();
	glTranslate(p);
	glRotatef(angle,axis.x(),axis.y(),axis.z());
	glScalef(size,size,size);
	glColor3f(.8,.8,.7);
	M.Draw();
	glPopMatrix();
}
/*
 v0


mp01     mp02
 

 v1     mp12       v2

*/

void Ast3DFract::Split(int seed,float strenght)
{
	Point3f BC(0,0,0); // The BaryCenter of the Asteroid
	vector<Triangle>::iterator i;
	for(i=M.T.begin();i!=M.T.end();i++)	{
			BC+=(*i).v[0];
			BC+=(*i).v[1];
			BC+=(*i).v[2];
	}
	BC/=(M.T.size()*3);
	Mesh M2;
	Point3f mp01,mp02,mp12;

	for(i=M.T.begin();i!=M.T.end();i++)	{
		mp01=MidPoint((*i).v[0],(*i).v[1],BC,seed,strenght);
		mp02=MidPoint((*i).v[0],(*i).v[2],BC,seed,strenght);
		mp12=MidPoint((*i).v[1],(*i).v[2],BC,seed,strenght);
		M2.T.reserve(M.T.size()*4);
		M2.T.push_back(Triangle((*i).v[0],mp01,mp02));
		M2.T.push_back(Triangle((*i).v[1],mp12,mp01));
		M2.T.push_back(Triangle((*i).v[2],mp02,mp12));
		M2.T.push_back(Triangle(mp12,mp02,mp01));
	}
	M=M2;
}

Point3f Ast3DFract::MidPoint(Point3f &p0, Point3f &p1, Point3f const &BC,int seed,float strenght)
{
	bool swapped=false;
	if(p0<p1){
		swap(p0,p1);
		swapped=true;
	}
	Point3f mp=(p0+p1)/2.0;
	float r=(Distance(p0,BC)+Distance(p1,BC))/2.0; // Radius
  float l=Distance(p0,p1);	// Edge Lenght
  l=l*strenght;
	srand48(seed + p0.Hash() + p1.Hash()); 
	float d=drand48()-0.5f;		// Displacement depends only on the two vertexes p0,p1
	
	mp=BC+Normalize(mp-BC)*(r+d*l/2.0);
	//mp=BC+Normalize(mp-BC)*r;
	if(swapped) swap(p0,p1);
	return mp;
}
